;##################################################################
; WinExplorer
;##################################################################

WIN32_FIND_DATA2 STRUCT
  dwFileAttributes      DD
  ftCreationTime        FILETIME <?>
  ftLastAccessTime      FILETIME <?>
  ftLastWriteTime       FILETIME <?>
  nFileSizeHigh         DD
  nFileSizeLow          DD
  dwReserved0           DD
  dwReserved1           DD
  cFileName             DB 260 dup (0)
  cAlternate            DB 14 dup (0)
ENDS

#include "WinExplorer.Inc"

#IFNDEF CONVLIB
	CONVLIB = C:\RadASM\GoAsm\Projects\Convert\Convert.lib
#ENDIF

#IFNDEF STRINGLIB
	STRINGLIB = C:\RadASM\GoAsm\Projects\Strings\Strings.lib
#ENDIF

szLen	= STRINGLIB:lszLen
szCopy	= STRINGLIB:lszCopy
szCat	= STRINGLIB:lszCat
szCmpi	= STRINGLIB:lszCmpi
szToken	= STRINGLIB:lszToken


dw2asc	= CONVLIB:dw2ascii

;#include "\RadASM\GoAsm\inc\debug.a"
;DBGWIN_DEBUG_ON = 1 ; use this to enable Spy/StopSpy/DbgDump and TrapException
;DBGWIN_SHOWONLYERRORS = 1 ; setting this to 1 will suppress PrintError if no error exists 

.DATA
	TVLock				DD	TRUE
	TreeViewRatio		DD	40

	hInstance			DD 	?
	hDlg				DD	?
	cyAdjustDlg			DD	?
	cxAdjustDlg			DD	?
	cyToolbar			DD	?
	hIcon				DD	?
	hStatusBar			DD	?
	hSplitter			DD	?
	hTreeView			DD	?
	hListView			DD	?
	hToolbar			DD	?
	hImlTreeView		DD	?
	hHeader				DD	?
	cyStatusbar			DD	?
	IsMoving			DD	?
	IsSizing			DD	?
	frect				RECT	<>
	hDivBar				DD	?

	ALIGN 16
	tbrbtns				TBBUTTON	<0,CMD_HELP,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0,0>
						TBBUTTON	<1,CMD_RUN,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,1,1>
						TBBUTTON	<2,CMD_FINDFILE,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,2,2>
						TBBUTTON	<3,CMD_CONSOLE,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,3,3>
			;			TBBUTTON	<4,CMD_TEST,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,4,4>

	tbbend:
	nToolbarBtns		equ			(tbbend-tbrbtns) /SIZEOF TBBUTTON

	szTBBtns:
	szTBBtn0			DB		"About",0
						DB		"Run",0
						DB		"Find File",0
						DB		"Console",0
						DB		"Test",0,0

	wfd					WIN32_FIND_DATA <>
	hFind				DD	0
	dcwfd				WIN32_FIND_DATA <>
	hdcFind				DD	0
	ffwfd				WIN32_FIND_DATA <>
	hffFind				DD	0

	ALIGN 16
	lvsort				LVSORT	<>
	ALIGN 16
	hdimage				HDRIMAGE	<-1,0>

	ThreadParam			DD	4 DUP (?)
	hThread				DD	0

	hSysImlLarge		DD	?
	hSysImlSmall		DD	?

	hImlToolbar			DD	?

	pszPath				DB	MAX_PATH DUP (?)

	pszSelPath			DB	MAX_PATH DUP (?)
	pszSelName			DB	MAX_PATH DUP (?)
	
	rfffolder			DB	MAX_PATH DUP (?)
	
	StringBuffer1		DB	256 DUP (?)
	StringBuffer2		DB	256 DUP (?)

	szColumn0			DB	"Name",0
	szColumn1			DB	"File type",0
	szColumn2			DB	"Size",0
	szColumn3			DB	"Last modified",0

	szFileTime			DB	64 DUP (?)
	szFileSize			DB	64 DUP (?)

	SearchSelect		DD	FALSE
	SearchWindow		DD	FALSE
	fContinue			DD	TRUE

	BIInfo				BFFINFO	<>

.CODE

Start:
	invoke GetModuleHandle, 0
	mov [hInstance],eax

	invoke CoInitialize,0

	invoke LoadCursor,[hInstance],5001
	mov [hDivBar],eax
	invoke InitSplitterClass
	
	invoke GetModuleHandle,"Shell32.DLL"
	invoke GetProcAddress,eax,660
	or eax,eax
	jz >
		push TRUE
		call eax
	:
	; Get a handle to the system imagelists, this is called by ordinal
	; Do not delete or modify these imagelists !!!!!
	; The listview MUST have the LVS_SHAREIMAGELISTS style
	invoke Shell_GetImageLists,offset hSysImlLarge,offset hSysImlSmall

	invoke InitCommonControls
	invoke DialogBoxParam,[hInstance],IDD_DLG1,0,ADDR DlgProc,NULL
	
	invoke CoUninitialize
	invoke ExitProcess,0

ToolbarSetup:
	invoke ImageList_LoadImage,[hInstance],IDR_TBBITMAP16,16,16,0FF00FFh,IMAGE_BITMAP,LR_CREATEDIBSECTION
	mov [hImlToolbar],eax
	invoke SendMessage,[hToolbar],TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,0

	invoke ImageList_SetBkColor,[hImlToolbar],CLR_NONE
	invoke SendMessage,[hToolbar],TB_SETIMAGELIST,0,[hImlToolbar]
	invoke SendMessage,[hToolbar],TB_SETINDENT,8,0
	invoke SendMessage,[hToolbar],TB_ADDBUTTONS,nToolbarBtns,OFFSET tbrbtns
	invoke SendMessage,[hToolbar],TB_ADDSTRING,NULL,OFFSET szTBBtns
	invoke SendMessage,[hToolbar],TB_AUTOSIZE,0,0
	RET

BuildDriveList FRAME
	uses edi,esi
	LOCAL DriveList[256]	:B
	LOCAL nDrive			:D
	LOCAL sfi				:SHFILEINFO
	LOCAL tvi				:TVITEM

	invoke GetLogicalDriveStrings,256,offset DriveList

	mov esi,offset DriveList
	mov edi,esi
	:
	inc esi
	mov al,[esi]
	or al,al
	jnz <

	invoke SHGetFileInfo,edi,NULL,offset sfi,SIZEOF SHFILEINFO,SHGFI_ICON+SHGFI_SMALLICON+SHGFI_USEFILEATTRIBUTES
	mov eax,[sfi.hIcon]
	mov B[esi-1],0
	invoke ImageList_ReplaceIcon,[hImlTreeView],-1,[sfi.hIcon]
	invoke TrvAddItem,[hTreeView],0,edi,eax,TRUE
	invoke DestroyIcon,[sfi.hIcon]

	inc esi
	mov edi,esi
	mov al,[esi]
	or al,al
	jnz <

	; Find the first fixed disk as a handle
	mov eax,"A:\"
	mov D[nDrive],eax
	:
		invoke GetDriveType, offset nDrive
		cmp eax, DRIVE_FIXED
		je >
		inc D[nDrive]
		cmp D[nDrive],"Z:\"
		jle <
		invoke SendMessage,[hTreeView],TVM_GETNEXTITEM,TVGN_ROOT,0
		ret
	:

	; Find the handle of the item

	lea eax,nDrive
	mov B[eax+2],0

	invoke TreeViewFindItem,0,offset nDrive

	RET
ENDF

DlgProc FRAME hwnd,uMsg,wParam,lParam
	uses ebx,edi,esi
	LOCAL pt			:POINT
	LOCAL hdi			:HDITEM
	LOCAL lvhi			:LV_HITTESTINFO
	LOCAL tvhi			:TV_HITTESTINFO
	LOCAL lvi			:LV_ITEM
	LOCAL tvi			:TVITEM
	LOCAL rect			:RECT
	LOCAL sfi			:SHFILEINFO
	LOCAL DoEventsID	:D
	LOCAL thExitcode	:D
	LOCAL DrvText[16]	:B

	.WM_INITDIALOG
	cmp D[uMsg],WM_INITDIALOG
	jne >>.WM_ERASEBKGND
		mov eax,[hwnd]
		mov [hDlg],eax

		invoke ImageList_LoadImage,[hInstance],5000,16,10,\
			0FFFFFFh,IMAGE_BITMAP,LR_DEFAULTCOLOR ;LR_CREATEDIBSECTION
		mov [hImlTreeView],eax

		invoke GetWindowRect,[hDlg],ADDR rect
		mov eax,[rect.bottom]
		sub eax,[rect.top]
		mov edi,eax
		mov eax,[rect.right]
		sub eax,[rect.left]
		mov esi,eax
		invoke GetClientRect,[hDlg],ADDR rect
		sub edi,[rect.bottom]
		mov [cyAdjustDlg],edi
		sub esi,[rect.right]
		mov [cxAdjustDlg],esi

		invoke LoadIcon,[hInstance],100
		mov [hIcon],eax
		invoke SendMessage,[hDlg],WM_SETICON,ICON_SMALL,[hIcon]
		invoke SendMessage,[hDlg],WM_SETICON,ICON_BIG,[hIcon]

		invoke GetDlgItem,[hwnd],IDC_STATUSBAR
		mov [hStatusBar],eax
		invoke GetDlgItem,[hwnd],IDC_SPLITTER
		mov [hSplitter],eax
		invoke GetDlgItem,[hwnd],IDC_TREEVIEW
		mov [hTreeView],eax
		invoke GetDlgItem,[hwnd],IDC_LISTVIEW
		mov [hListView],eax
		invoke GetDlgItem,[hwnd],IDC_TOOLBAR
		mov [hToolbar],eax
		invoke ToolbarSetup
		invoke ListViewSetup
		invoke SendMessage,[hTreeView],TVM_SETIMAGELIST,0,[hImlTreeView]

		invoke GetStockObject,DEFAULT_GUI_FONT
		push eax
		invoke SendMessage,[hTreeView],WM_SETFONT,eax,TRUE
		pop eax
		invoke SendMessage,[hListView],WM_SETFONT,eax,TRUE

		invoke GetClassLong,[hwnd],GCL_HCURSOR
		invoke SetWindowLong,[hwnd],GWL_USERDATA,eax

		invoke GetClientRect,[hStatusBar],OFFSET rect
		mov eax,[rect.bottom]
		mov [cyStatusbar],eax

		invoke GetClientRect,[hToolbar],OFFSET rect
		mov eax,[rect.bottom]
		mov [cyToolbar],eax

		invoke BuildDriveList
		invoke SendMessage,[hTreeView],TVM_SELECTITEM,TVGN_CARET,eax
		jmp >>.EXIT

	.WM_ERASEBKGND
	cmp D[uMsg],WM_ERASEBKGND
	jne >.WM_ENTERSIZEMOVE
		cmp D[IsMoving],TRUE
		jne >>.DEFPROC
		xor eax,eax
		inc eax
		ret

	.WM_ENTERSIZEMOVE
	cmp D[uMsg],WM_ENTERSIZEMOVE
	jne >.WM_EXITSIZEMOVE
		mov D[IsMoving],TRUE
		xor eax,eax
		ret

	.WM_EXITSIZEMOVE
	cmp D[uMsg],WM_EXITSIZEMOVE
	jne >.WM_GETMINMAXINFO
		mov D[IsMoving],FALSE
		invoke InvalidateRect,[hwnd],NULL,TRUE
		invoke UpdateWindow,[hwnd]
		xor eax,eax
		ret

	.WM_GETMINMAXINFO
	cmp D[uMsg],WM_GETMINMAXINFO
	jne >.WM_WINDOWPOSCHANGED
		mov edi,[lParam]
		mov D[edi+MINMAXINFO.ptMinTrackSize.x],MINWIDTH
		mov D[edi+MINMAXINFO.ptMinTrackSize.y],MINHEIGHT
		xor eax,eax
		ret

	.WM_WINDOWPOSCHANGED
	cmp D[uMsg],WM_WINDOWPOSCHANGED
	jne >.WM_COMMAND
		mov edi,[lParam]
		mov D[rect.left],0
		mov D[rect.top],0
		mov eax,[edi+WINDOWPOS.lx]
		sub eax,[cxAdjustDlg] ; border
		mov [rect.right],eax
		mov eax,[edi+WINDOWPOS.cy]
		sub eax,[cyAdjustDlg] ; caption + border
		mov [rect.bottom],eax
		invoke ResizeWindow,OFFSET rect,[TVLock]
		jmp >>.EXIT

	.WM_COMMAND
	cmp D[uMsg],WM_COMMAND
	jne >>.WM_CONTEXTMENU
		movzx eax,W[wParam+2]
		movzx edx,W[wParam]
		cmp edx,CMD_HELP
		jne >
			invoke MessageBox,[hwnd],"GoAsm WinExplorer by Donkey","About",MB_OK
			jmp >>.EXIT
		:
		cmp edx,CMD_RUN
		jne >
			invoke RunFileDlg,[hDlg],[hIcon],NULL,NULL,NULL,RFF_NODEFAULT + RFF_CALCDIRECTORY
			jmp >>.EXIT
		:
		cmp edx,CMD_FINDFILE
		jne >
			invoke SendMessage,[hTreeView],TVM_GETNEXTITEM,TVGN_CARET,0
			invoke BuildPathFromTreeview,eax,offset pszSelPath
			invoke DialogBoxParam,[hInstance],2000,[hwnd],offset FindDlgProc,offset pszSelPath

		;	invoke SHFindFiles,NULL,NULL
		;	invoke FindWindow,NULL,"Search Results"
		;	invoke BringWindowToTop,eax
			jmp >>.EXIT
		:
		cmp edx,CMD_CONSOLE
		jne >>
			invoke SendMessage,[hTreeView],TVM_GETNEXTITEM,TVGN_CARET,0
			invoke BuildPathFromTreeview,eax,offset pszSelPath
			invoke szCat,offset pszSelPath,"\"
			invoke Is9x
			or eax,eax
			jnz >C1
				invoke ShellExecute,NULL,"open","cmd.exe",NULL,offset pszSelPath,SW_SHOW
				jmp >>.EXIT
			C1:
				invoke ShellExecute,NULL,"open","command.com",NULL,offset pszSelPath,SW_SHOW
				jmp >>.EXIT
		:
		cmp edx,CMD_TEST
		jne >>.EXIT
		;	invoke PathTohItem,offset testpath
		jmp >>.EXIT

	.WM_CONTEXTMENU
	cmp D[uMsg],WM_CONTEXTMENU
	jne >.WM_NOTIFY
		invoke ListviewSelectView,[hwnd]
		xor eax,eax
		inc eax
		ret

	.WM_NOTIFY
	cmp D[uMsg],WM_NOTIFY
	jne >>.WM_LBUTTONUP
		mov edi,[lParam]
		.TVN_SELCHANGED
		cmp D[edi+NMHDR.code],TVN_SELCHANGED
		jne >>.NM_CLICK
			cmp D[SearchSelect],TRUE
			jne >
				mov D[SearchSelect],FALSE
				ret
			:
			mov D[SearchWindow],FALSE
			mov ebx,[edi+NMTREEVIEW.itemNew.hItem]
			mov D[tvi.imask],TVIF_PARAM
			mov [tvi.hItem],ebx
			invoke SendMessage,[hTreeView],TVM_GETITEM,0,offset tvi

			invoke BuildPathFromTreeview,ebx,offset pszPath
			cmp D[hThread],0
			je >>T1
				invoke GetExitCodeThread,[hThread],offset thExitcode
				mov eax,[thExitcode]
				test eax,STILL_ACTIVE
				jz >
				invoke TerminateThread,[hThread],0
					cmp D[hFind],0
					je >F1
						invoke FindClose,[hFind]
						mov D[hFind],0
					F1:
				; The folder was not completely enumerated so set the
				; flag to false
				mov D[tvi.lParam],FALSE
				mov D[tvi.imask],TVIF_PARAM+TVIF_HANDLE
				mov eax,[ThreadParam+4]
				mov D[tvi.hItem],eax
				invoke SendMessage,[hTreeView],TVM_SETITEM,0,offset tvi
				:
				invoke CloseHandle,[hThread]
				mov D[hThread],0
			T1:
			
			mov D[ThreadParam],offset pszPath
			mov [ThreadParam+4],ebx
			mov eax,[tvi.lParam]
			mov [ThreadParam+8],eax

			invoke SendMessage,[hListView],LVM_DELETEALLITEMS,0,0
			invoke CreateThread,NULL,NULL,OFFSET WorkerThread,offset ThreadParam,NULL,ADDR DoEventsID
			mov [hThread],eax
			invoke SetThreadPriority,eax,THREAD_PRIORITY_ABOVE_NORMAL

			mov D[tvi.lParam],TRUE
			mov D[tvi.imask],TVIF_PARAM+TVIF_HANDLE
			mov D[tvi.hItem],ebx
			invoke SendMessage,[hTreeView],TVM_SETITEM,0,offset tvi

			jmp >>.EXIT

		.NM_CLICK
		cmp D[edi+NMHDR.code],NM_CLICK
		jne >>.NM_DBLCLK
			mov eax,[edi+NMHDR.hwndFrom]
			cmp eax,[hTreeView]
			jne >>.EXIT
			invoke GetCursorPos,offset tvhi.pt
			invoke ScreenToClient,[hTreeView],offset tvhi.pt
			invoke SendMessage,[hTreeView],TVM_HITTEST,0,offset tvhi
			mov eax,[tvhi.flags]
			test eax,TVHT_ONITEMBUTTON
			jz >>.EXIT
				mov eax,[tvhi.hItem]
				mov [tvi.hItem],eax
				mov D[tvi.imask],TVIF_STATE
				invoke SendMessage,[hTreeView],TVM_GETITEM,0,offset tvi
				mov eax,[tvi.state]
				test eax,TVIS_EXPANDEDONCE
				jnz >>.DEFPROC
					invoke PostMessage,[hTreeView],TVM_SELECTITEM,TVGN_CARET,[tvhi.hItem]
						jmp >>.EXIT

		.NM_DBLCLK
		cmp D[edi+NMHDR.code],NM_DBLCLK
		jne >>.HDN_ITEMCLICK
			mov eax,[edi+NMHDR.hwndFrom]
			cmp eax,[hListView]
			jne >>.EXIT
				invoke SendMessage,[hListView],LVM_GETNEXTITEM,-1,LVNI_FOCUSED
				or eax,eax
				js >>.EXIT
				mov [lvi.iItem],eax
				mov D[lvi.iSubItem],0
				mov D[lvi.imask],LVIF_PARAM+LVIF_TEXT
				mov [lvi.pszText],offset pszSelName
				mov D[lvi.cchTextMax],MAX_PATH
				invoke SendMessage,[hListView],LVM_GETITEM,0,offset lvi
				invoke BuildPathFromTreeview,[lvi.lParam],offset pszSelPath
				invoke szCat,offset pszSelPath,"\"
				invoke szCat,offset pszSelPath,offset pszSelName
				invoke ShellExecute,NULL,"Open",offset pszSelPath,NULL,NULL,SW_SHOW
				jmp >>.EXIT

		.HDN_ITEMCLICK
		cmp D[edi+NMHDR.code],HDN_ITEMCLICK
		jnz >>.HDN_ITEMCHANGED
			mov D[hdi._mask],HDI_IMAGE + HDI_FORMAT
			invoke SendMessage,[hHeader],HDM_GETITEM,[edi+NMHEADER.iItem],ADDR hdi
			test D[hdi.fmt],HDF_IMAGE
			jz >>.EXIT
				mov eax,[hdimage.dwItem]
				mov ecx,1
				or eax,eax
				js >H1
					cmp eax,[edi+NMHEADER.iItem]
					je >H2
						mov ecx,0
						invoke SendMessage,[hHeader],HDM_SETITEM,[hdimage.dwItem],ADDR hdi
						mov D[hdimage.dwDir],1
						mov ecx,1
						jmp >H1
					H2:
						mov ecx,[hdimage.dwDir]
						test ecx,1
						je >
							mov ecx,2
							jmp >H1
						:
							mov ecx,1
				H1:
				mov eax,[edi+NMHEADER.iItem]
				mov [hdimage.dwItem],eax
				mov [hdi.iImage],ecx
				mov [hdimage.dwDir],ecx
				; D[hdi.iItem] = the header item that was clicked
				; D[hdi.iImage] = the current image
				; set to 0 = no arrow, 1 = down arrow, 2 = up arrow
				invoke SendMessage,[hHeader],HDM_SETITEM,[edi+NMHEADER.iItem],ADDR hdi

				; Sort the column by text based on the direction arrow
				mov eax,[hListView]
				mov [lvsort.handle],eax ; Handle of the listview to sort
				mov eax,[hdimage.dwDir]
				shr eax,1
				mov D[lvsort.direction],eax ; FALSE = ascending , TRUE = descending
				mov eax,[edi+NMHEADER.iItem]
				mov D[lvsort.column],eax ; Column to sort
				cmp eax,0
				jne >
					mov D[lvsort.type],1 ; sort by name (alpha)
					jmp >H3
				:
				cmp eax,1
				jne >
					mov D[lvsort.type],1 ; sort by type (alpha)
					jmp >H3
				:
				
				cmp eax,2
				jne >
					mov D[lvsort.type],2 ; sort by size 2
					jmp >H3
				:
				cmp eax,3
				jne >
					mov D[lvsort.type],3 ; sort by date 3
					jmp >H3
				:
				
				mov D[lvsort.type],1
				H3:
				invoke SendMessage, [hListView], LVM_SORTITEMSEX, OFFSET lvsort, OFFSET ListviewSortProc
				jmp >>.EXIT

		.HDN_ITEMCHANGED
		cmp D[edi+NMHDR.code],HDN_ITEMCHANGED
		jnz >.TVN_GETDISPINFO
			; Redraw the listview when header resized
			invoke InvalidateRect,[hListView],NULL,NULL
			invoke UpdateWindow,[hListView]
			jmp >>.EXIT

		.TVN_GETDISPINFO
		cmp D[edi+NMHDR.code],TVN_GETDISPINFO
		jnz >>.LVN_ITEMCHANGED
			mov eax,[edi+NMTVDISPINFO.item.hItem]
			mov [tvi.hItem],eax
			mov D[tvi.imask],TVIF_STATE+TVIF_CHILDREN
			invoke SendMessage,[hTreeView],TVM_GETITEM,0,offset tvi
			mov eax,[tvi.state]
			test eax,TVIS_EXPANDED
			jnz >E1
			test eax,TVIS_SELECTED ; Special case for selected folders with no children
			jz >
			cmp D[tvi.cChildren],0
			je >E1
			:
				; unexpanded
				mov D[edi+NMTVDISPINFO.item.iSelectedImage],IMG_FOLDER
				mov D[edi+NMTVDISPINFO.item.iImage],IMG_FOLDER
				jmp >>.EXIT
			E1:
				; expanded
				mov D[edi+NMTVDISPINFO.item.iSelectedImage],IMG_OPENFOLDER
				mov D[edi+NMTVDISPINFO.item.iImage],IMG_OPENFOLDER

				jmp >>.EXIT

		.LVN_ITEMCHANGED
		cmp D[edi+NMHDR.code],LVN_ITEMCHANGED
		jnz >>.EXIT
		cmp D[SearchWindow],TRUE
		jne >>.EXIT
			mov D[SearchSelect],FALSE
			mov ebx,[edi+NMLISTVIEW.lParam]
			or ebx,ebx
			jz >>.EXIT
				mov eax,[edi+NMLISTVIEW.uNewState]
				test eax,LVIS_SELECTED
				jz >>.EXIT
					mov D[SearchSelect],TRUE
					invoke PostMessage,[hTreeView],TVM_SELECTITEM,TVGN_CARET,ebx
			jmp >>.EXIT

	.WM_LBUTTONUP
	cmp D[uMsg],WM_LBUTTONUP
	jne >>.WM_MOUSEMOVE
		cmp D[IsSizing],TRUE
		jne >>.EXIT
			mov D[IsSizing],FALSE
			invoke ReleaseCapture
			invoke ClipCursor,NULL

			invoke GetDlgItem,[hwnd],IDC_SPLITTER
			mov ebx,eax
			invoke SetClassLong,ebx,GCL_HBRBACKGROUND,COLOR_BTNFACE + 1 ;[hSplitBrush]
			invoke InvalidateRect,ebx,NULL,TRUE
			invoke UpdateWindow,ebx

			invoke GetDC,[hDlg]
			mov ebx,eax
			invoke DrawFocusRect,ebx,ADDR frect
			invoke ReleaseDC,[hDlg],ebx

			invoke GetWindowRect,[hTreeView],ADDR rect
			invoke GetCursorPos,ADDR pt
			mov eax,[pt.x]
			sub eax,[rect.left]
			push eax
			invoke GetClientRect,[hwnd],ADDR rect
			pop eax
			mov ecx,[rect.right]
			mov edx,100
			mul edx
			xor edx,edx
			div ecx
			mov [TreeViewRatio],eax
			invoke ResizeWindow,OFFSET rect,0
			xor eax,eax
			ret

	.WM_MOUSEMOVE
	cmp D[uMsg],WM_MOUSEMOVE
	jne >.WM_CLOSE
		cmp D[IsSizing],TRUE
		jne >>
			invoke GetCursorPos,ADDR pt
			invoke ScreenToClient,[hDlg],ADDR pt
			invoke GetDC,[hDlg]
			mov ebx,eax
			invoke DrawFocusRect,ebx,ADDR frect
			mov eax,[pt.x]
			add eax,1
			mov [frect.right],eax
			invoke DrawFocusRect,ebx,ADDR frect
			invoke ReleaseDC,[hDlg],ebx
			xor eax,eax
			ret
		:
		jmp >>.EXIT

	.WM_CLOSE
	cmp D[uMsg],WM_CLOSE
	jne >.DEFPROC
		invoke ImageList_Destroy,[hImlTreeView]
		cmp D[hThread],0
		je >
			invoke TerminateThread,[hThread],0
			invoke CloseHandle,[hThread]
		:
		INVOKE EndDialog,[hwnd],0

	.DEFPROC
		xor eax,eax
		ret

	.EXIT

	xor eax,eax
	inc eax
	ret
ENDF

ListViewSetup FRAME 
	uses edi,esi
	LOCAL LVColumn		:LV_COLUMN
	LOCAL hdi			:HDITEM

	invoke SendMessage,[hListView],LVM_SETIMAGELIST,LVSIL_SMALL,[hSysImlSmall]
	invoke SendMessage,[hListView],LVM_SETIMAGELIST,LVSIL_NORMAL,[hSysImlLarge]
;	invoke SendMessage,[hListView],LVM_SETTEXTCOLOR,0,TEXTCOLOR

	mov D[LVColumn.imask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH
	mov D[LVColumn.fmt],LVCFMT_LEFT
	mov D[LVColumn.lx],132
	mov D[LVColumn.pszText],OFFSET szColumn0
	mov D[LVColumn.cchTextMax],SIZEOF szColumn0
	invoke SendMessage,[hListView],LVM_INSERTCOLUMN,0,ADDR LVColumn

	mov D[LVColumn.imask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH
	mov D[LVColumn.fmt],LVCFMT_CENTER
	mov D[LVColumn.lx],100
	mov D[LVColumn.pszText],OFFSET szColumn1
	mov D[LVColumn.cchTextMax],SIZEOF szColumn1
	invoke SendMessage,[hListView],LVM_INSERTCOLUMN,1,ADDR LVColumn

	mov D[LVColumn.imask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH + LVCF_SUBITEM
	mov D[LVColumn.fmt],LVCFMT_RIGHT
	mov D[LVColumn.lx],90
	mov D[LVColumn.pszText],OFFSET szColumn2
	mov D[LVColumn.cchTextMax],SIZEOF szColumn2
	mov D[LVColumn.iSubItem],1
	invoke SendMessage,[hListView],LVM_INSERTCOLUMN,2,ADDR LVColumn

	mov D[LVColumn.imask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH + LVCF_SUBITEM
	mov D[LVColumn.fmt],LVCFMT_RIGHT
	mov D[LVColumn.lx],130
	mov D[LVColumn.pszText],OFFSET szColumn3
	mov D[LVColumn.cchTextMax],SIZEOF szColumn3
	mov D[LVColumn.iSubItem],2
	invoke SendMessage,[hListView],LVM_INSERTCOLUMN,3,ADDR LVColumn


	invoke SendMessage,[hListView],LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_FULLROWSELECT + LVS_EX_GRIDLINES + LVS_EX_HEADERDRAGDROP,LVS_EX_GRIDLINES + LVS_EX_FULLROWSELECT + LVS_EX_HEADERDRAGDROP 

	invoke SendMessage,[hListView],LVM_GETHEADER,0,0
	mov [hHeader],eax

	invoke ImageList_LoadImage,[hInstance],5002,16,0,08000FFh,IMAGE_BITMAP,LR_CREATEDIBSECTION
	invoke SendMessage,[hHeader],HDM_SETIMAGELIST,0,eax
	mov D[hdi._mask],HDI_FORMAT + HDI_IMAGE
	mov D[hdi.fmt],HDF_IMAGE + HDF_STRING + HDF_BITMAP_ON_RIGHT
	mov D[hdi.iImage],0

	invoke SendMessage,[hHeader],HDM_GETITEMCOUNT,0,0
	dec eax
	mov edi,eax
	:
		invoke SendMessage,[hHeader],HDM_SETITEM,edi,ADDR hdi
		dec edi
	jns <

	ret
ENDF

ResizeWindow FRAME pRect,LockTreeView
	uses edi,ebx,esi
	LOCAL rect			:RECT
	LOCAL lvl			:D
	LOCAL vertcorrect	:D

	; right side of treeview +6
	; top of treeview + size of the toolbar
	; treview TreeViewRatio% of window width
	; right side of listview = right treeview + 5
	; left side of listview -6

	mov ebx,0 ; if toolbar has a top edge set to 2
	mov edi,3 ; Space between controls
	mov esi,[TreeViewRatio] ; percentage of window width for TreeView

	mov eax,[cyStatusbar] ; Status bar height
	add eax,[cyToolbar] ; Toolbar height
	add eax,ebx
	add eax,ebx
	mov [vertcorrect],eax

	cmp D[LockTreeView],FALSE
	jne >
	; Calculate width of treeview for all other references
	mov eax,[pRect]
	mov eax,[eax+RECT.right]
	mul esi
	; Devide by 100 from The Svin's magic number
	mov edx,2748779069
	inc eax
	mul edx
	shr edx, 6
	mov eax,edx
	jmp >T1
	:
	invoke GetWindowRect,[hTreeView],OFFSET rect
	mov eax,[rect.right]
	sub eax,[rect.left]
	T1:

	; move the treeview
	mov [rect.right],eax
	add eax,ebx
	add eax,edi
	mov [lvl],eax

	mov D[rect.left],ebx

	; mov eax,[tboffset]
	mov eax,[cyToolbar]
	add eax,ebx ; add the border
	mov D[rect.top],eax

	mov eax,[pRect]
	mov eax,[eax+RECT.bottom]
	sub eax,[vertcorrect]
	mov D[rect.bottom],eax

	invoke MoveWindow,[hTreeView],[rect.left],[rect.top],[rect.right],[rect.bottom],TRUE

	; Move the splitter bar
	mov eax,[rect.right]
	add eax,ebx ; add the border
	mov [rect.left],eax
	mov D[rect.right],3

	invoke MoveWindow,[hSplitter],[rect.left],[rect.top],[rect.right],[rect.bottom],TRUE

	; move the listview
	mov eax,[lvl]
	mov [rect.left],eax
	; calculate the new width
	mov eax,[pRect]
	mov eax,[eax+RECT.right]
	sub eax,[lvl]
	sub eax,ebx
	mov [rect.right],eax

;	There is no need to recalculate the top and height, they match the treeview

;	mov eax,[tboffset]
;	mov D[rect.top],eax
	
;	mov eax,[pRect]
;	mov eax,[eax+RECT.bottom]
;	sub eax,[vertcorrect]
;	mov D[rect.bottom],eax

	invoke MoveWindow,[hListView],[rect.left],[rect.top],[rect.right],[rect.bottom],TRUE

	; Redraw the toolbar & Status bar
	invoke SendMessage,[hToolbar],TB_AUTOSIZE,0,0
	mov eax,[pRect]
	mov eax,[eax+RECT.bottom]
	sub eax,[rect.bottom]
	invoke SetWindowPos,[hStatusBar],NULL,0,eax,0,0,SWP_NOZORDER

	RET
ENDF

SplitterProc FRAME hwnd,uMsg,wParam,lParam
	LOCAL rect	:RECT
	LOCAL pt	:POINT
	LOCAL ps	:PAINTSTRUCT

	cmp D[uMsg],WM_LBUTTONDOWN
	jne >>
		mov D[IsSizing],TRUE
			invoke SetCursor,[hDivBar]
			invoke SetCapture,[hDlg]
			
			invoke GetStockObject,BLACK_BRUSH
			invoke SetClassLong,[hwnd],GCL_HBRBACKGROUND,eax
			invoke InvalidateRect,[hwnd],NULL,TRUE
			invoke UpdateWindow,[hwnd]

			; Calculate the limits for right, left, top and bottom motion
			; the treeview can be a minimum of MINSPLIT% of the dlg size
			; the treeview can be a maximum of MAXSPLIT% of the dlg size
			; The cursor also should be confined to the vertical work area
			invoke GetClientRect,[hDlg],ADDR rect
			; find MINSPLIT
			mov eax,[rect.right]
			mov ecx,MINSPLIT
			mul	ecx
			mov ecx,100
			xor edx,edx
			div ecx
			push eax
			; find MAXSPLIT
			mov eax,[rect.right]
			mov ecx,MAXSPLIT
			mul	ecx
			mov ecx,100
			xor edx,edx
			div ecx
			push eax

			invoke GetWindowRect,[hTreeView],ADDR rect
			invoke ScreenToClient,[hDlg],ADDR rect
			invoke ScreenToClient,[hDlg],ADDR rect.right

			pop eax
			mov [rect.right],eax
			pop eax
			mov [rect.left],eax

			invoke ClientToScreen,[hDlg],ADDR rect
			invoke ClientToScreen,[hDlg],ADDR rect.right
			invoke ClipCursor,ADDR rect

			; Get the bounding rect of the treeview
			; relative to the dialog box
			invoke GetWindowRect,[hTreeView],ADDR frect
			invoke ScreenToClient,[hDlg],ADDR frect
			invoke ScreenToClient,[hDlg],ADDR frect.right

			invoke GetCursorPos,ADDR pt
			invoke ScreenToClient,[hDlg],ADDR pt
			mov eax,[pt.x]
			inc eax
			mov D[frect.right],eax

			invoke GetDC,[hDlg]
			mov ebx,eax
			invoke DrawFocusRect,ebx,ADDR frect
			invoke ReleaseDC,[hDlg],ebx

			xor eax,eax
			ret
	:

	invoke DefWindowProc,[hwnd],[uMsg],[wParam],[lParam]
	
	RET
ENDF

InitSplitterClass FRAME
	LOCAL wcx		:WNDCLASSEX

	mov D[wcx.cbSize],SIZEOF WNDCLASSEX
	mov D[wcx.style], CS_HREDRAW + CS_VREDRAW
	mov eax,[hInstance]
	mov D[wcx.hInstance],eax
	mov D[wcx.lpszClassName],OFFSET UDC_SplitterClass
	mov D[wcx.cbClsExtra],0
	mov D[wcx.cbWndExtra],0
	mov D[wcx.lpfnWndProc],OFFSET SplitterProc
	mov D[wcx.hIcon],NULL
	mov D[wcx.hIconSm],NULL
;	mov eax,[hSplitBrush]
	mov D[wcx.hbrBackground],COLOR_BTNFACE+1 ;eax
	mov D[wcx.lpszMenuName],NULL

	mov eax,[hDivBar]
	mov [wcx.hCursor],eax

	invoke RegisterClassEx,ADDR wcx

	ret

	UDC_SplitterClass:	DB		"UDC_Splitter",0

ENDF

ReadDir FRAME pszFolder,hParent,lParam
	LOCAL folder[MAX_PATH]	:B
	LOCAL tvi				:TVITEM

	invoke SendMessage,[hListView],LVM_DELETEALLITEMS,0,0
	mov eax,[lParam]
	or eax,eax
	jnz >
		; If the thread was interupted then the folders must be redone
		invoke SendMessage,[hTreeView],TVM_EXPAND,TVE_COLLAPSE + TVE_COLLAPSERESET,[hParent]
	:

	invoke szCopy,offset folder,[pszFolder]
	invoke szCat,offset folder,"\*"
	invoke FindFirstFile,offset folder,OFFSET wfd
	mov [hFind],eax
	L1:
		mov eax,[wfd.dwFileAttributes]
		test eax,FILE_ATTRIBUTE_HIDDEN
		jnz >>.NEXTITEM
		test eax,FILE_ATTRIBUTE_DIRECTORY
		jz >.FILE
		mov eax,[lParam]
		or eax,eax
		jnz >.NEXTITEM
			mov eax,[wfd.cFileName]
			and eax,0FFFFFFh
			cmp eax,2E2Eh
			je >
			and eax,0FFFFh
			cmp eax,2Eh
			je >
			invoke DetectChildren,offset folder,offset wfd.cFileName
			invoke TrvAddItem,[hTreeView],[hParent],offset wfd.cFileName,I_IMAGECALLBACK,eax
			:
			jmp >.NEXTITEM
		.FILE
			invoke FileToListview,offset folder,offset wfd.cFileName,[hParent],offset wfd
	.NEXTITEM
	invoke FindNextFile,[hFind],offset wfd
	or eax,eax
	jne	<<L1

	;No more matches, close handle
	invoke FindClose,[hFind]
	mov D[hFind],0

	invoke SendMessage,[hTreeView],TVM_GETNEXTITEM,TVGN_CHILD,[hParent]
	or eax,eax
	jnz >
		mov D[tvi.imask],TVIF_CHILDREN +TVIF_PARAM
		mov eax,[hParent]
		mov [tvi.hItem],eax
		mov D[tvi.cChildren],0
		mov D[tvi.lParam],TRUE
		invoke SendMessage,[hTreeView],TVM_SETITEM,0,offset tvi
	:

	xor eax,eax
	RET
	
ENDF

FileToListview FRAME pFilePath,pFileName,hTVPar,pwfd
	uses edi,ebx
	LOCAL NameBuf[MAX_PATH]		:B
	LOCAL szTempDate[64]		:B
	LOCAL szTempTime[64]		:B
	LOCAL stLocal				:SYSTEMTIME
	LOCAL sfi					:SHFILEINFO

	invoke szCopy,offset NameBuf,[pFilePath]
	invoke szLen,offset NameBuf
	lea eax,[NameBuf+eax-1]
	invoke szCopy,eax,[pFileName]

	; Get the icon index
	invoke SHGetFileInfo,OFFSET NameBuf,NULL,offset sfi,SIZEOF SHFILEINFO,SHGFI_SYSICONINDEX+SHGFI_TYPENAME

	mov ebx,[pwfd]
	mov eax,ebx
	add eax,WIN32_FIND_DATA.ftLastWriteTime

	invoke FileTimeToSystemTime,eax,OFFSET stLocal
	invoke GetDateFormat,LOCALE_SYSTEM_DEFAULT,NULL,\
		OFFSET stLocal,"dd MMM yyyy",OFFSET szTempDate,64

	invoke GetTimeFormat,LOCALE_SYSTEM_DEFAULT,NULL,\
		OFFSET stLocal,"hh:mm tt",OFFSET szTempTime,64

	invoke szCopy,OFFSET szFileTime,OFFSET szTempDate
	invoke szCat,OFFSET szFileTime," "
	invoke szCat,OFFSET szFileTime,OFFSET szTempTime

	invoke dw2asc,[ebx+WIN32_FIND_DATA.nFileSizeLow],OFFSET szFileSize
	invoke szCat,OFFSET szFileSize," bytes"

	invoke ListviewAddItem,[sfi.iIcon],[pFileName],OFFSET szFileSize,OFFSET szFileTime,offset sfi.szTypeName,[hTVPar]
	RET
ENDF

TrvAddItem FRAME hTrv,hPar,lpPth,nImg,bChildren
	LOCAL	tvins			:TV_INSERTSTRUCT

	mov eax,[hPar]
	mov [tvins.hParent],eax

	mov D[tvins.itemex.lParam],FALSE

	mov D[tvins.hInsertAfter],0
	mov D[tvins.itemex.imask],TVIF_TEXT + TVIF_PARAM + TVIF_IMAGE + TVIF_SELECTEDIMAGE + TVIF_CHILDREN
	mov eax,[lpPth]
	mov [tvins.itemex.pszText],eax

	mov eax,[bChildren]
	mov D[tvins.itemex.cChildren],eax

	mov eax,[nImg]
	mov D[tvins.itemex.iImage],eax
	mov D[tvins.itemex.iSelectedImage],eax
	invoke SendMessage,[hTrv],TVM_INSERTITEM,0,addr tvins

    ret

ENDF

ListviewAddItem FRAME Image,pFileTitle,pFileSize,pFileDate,pFileType,lParam
	LOCAL LVItem		:LV_ITEM
	LOCAL szItemID[16]	:B
	LOCAL ItemID		:D

	invoke SendMessage,[hListView],LVM_GETITEMCOUNT,0,0
	mov [ItemID],eax

	mov D[LVItem.imask],LVIF_PARAM + LVIF_TEXT + LVIF_IMAGE
	mov D[LVItem.iSubItem],0
	mov eax,[pFileTitle]
	mov [LVItem.pszText],eax

	mov eax,[Image]
	mov [LVItem.iImage],eax
	mov eax,[lParam]
	mov D[LVItem.lParam],eax
	mov eax,[ItemID]
	mov [LVItem.iItem],eax
	invoke SendMessage,[hListView],LVM_INSERTITEM,0,ADDR LVItem
	mov [ItemID],eax

	mov eax,[pFileType]
	mov [LVItem.pszText],eax
	mov eax,[ItemID]
	mov [LVItem.iItem],eax
	mov D[LVItem.iSubItem],1
	mov D[LVItem.imask],LVIF_TEXT
	invoke SendMessage,[hListView],LVM_SETITEM,0,ADDR LVItem

	mov eax,[pFileSize]
	mov [LVItem.pszText],eax
	mov eax,[ItemID]
	mov [LVItem.iItem],eax
	mov D[LVItem.iSubItem],2
	mov D[LVItem.imask],LVIF_TEXT
	invoke SendMessage,[hListView],LVM_SETITEM,0,ADDR LVItem

	mov eax,[pFileDate]
	mov [LVItem.pszText],eax
	mov eax,[ItemID]
	mov [LVItem.iItem],eax
	mov D[LVItem.iSubItem],3
	mov D[LVItem.imask],LVIF_TEXT
	invoke SendMessage,[hListView],LVM_SETITEM,0,ADDR LVItem

	mov eax,[ItemID]
	ret
ENDF

ListviewSortProc FRAME lParam1,lParam2,lParamSort
	uses ebx,edi,esi
	LOCAL	ItemData1			:LV_ITEM
	LOCAL	ItemData2			:LV_ITEM
	LOCAL	Tbuff1[256]			:B
	LOCAL	Tbuff2[256]			:B
	
	LOCAL	Fbuff1[MAX_PATH]	:B
	LOCAL	Fbuff2[MAX_PATH]	:B
	
	LOCAL	FName1[MAX_PATH]	:B
	LOCAL	FName2[MAX_PATH]	:B
	
	LOCAL	wfd1				:WIN32_FIND_DATA
	LOCAL	wfd2				:WIN32_FIND_DATA

	; lParamSort pointer to LVSORT structure
	mov edi,[lParamSort]
	mov ebx,[edi+LVSORT.column]
	mov esi,[edi+LVSORT.handle]

	; get the file name
	mov eax,[lParam1]
	mov [ItemData1.iItem],eax
	mov D[ItemData1.iSubItem],0
	mov D[ItemData1.imask],LVIF_TEXT + LVIF_PARAM + LVIF_IMAGE
	lea eax,FName1
	add eax,1
	mov B[FName1],"\"
	mov [ItemData1.pszText],eax
	mov D[ItemData1.cchTextMax],255
	invoke SendMessage,esi,LVM_GETITEM,0,OFFSET ItemData1

	mov [ItemData1.iSubItem],ebx
	lea eax,Tbuff1
	mov [ItemData1.pszText],eax
	invoke SendMessage,esi,LVM_GETITEM,0,OFFSET ItemData1

	mov eax,[lParam2]
	mov [ItemData2.iItem],eax
	mov D[ItemData2.iSubItem],0
	mov D[ItemData2.imask],LVIF_TEXT + LVIF_PARAM + LVIF_IMAGE
	lea eax,FName2
	add eax,1
	mov B[FName2],"\"
	mov [ItemData2.pszText],eax
	mov D[ItemData2.cchTextMax],255
	invoke SendMessage,esi,LVM_GETITEM,0,OFFSET ItemData2

	mov [ItemData2.iSubItem],ebx
	lea eax,Tbuff2
	mov [ItemData2.pszText],eax
	invoke SendMessage,esi,LVM_GETITEM,0,OFFSET ItemData2

	mov esi,[edi+LVSORT.direction]
	; Other sorts
	cmp D[edi+LVSORT.type],1
	jb >P1
	ja >S1

	invoke szLen,OFFSET Tbuff1
	or eax,eax
	jnz >
		mov eax,1
		ret
	:

	invoke szLen,OFFSET Tbuff2
	or eax,eax
	jnz >
		mov eax,-1
		ret
	:

	; String sort
	invoke szCmpi,OFFSET Tbuff1,OFFSET Tbuff2
	or esi,esi
	jz >
		neg eax
	:
	ret

	; Type 0 sort unused
	P1:
	mov eax,0
	ret


	; File size sort (2)
	S1:
	invoke BuildPathFromTreeview,[ItemData1.lParam],offset Fbuff1
	invoke szCat,offset Fbuff1,OFFSET FName1
	invoke BuildPathFromTreeview,[ItemData1.lParam],offset Fbuff2
	invoke szCat,offset Fbuff2,OFFSET FName2
	invoke FindFirstFile,offset Fbuff1,ADDR wfd1
	invoke FindClose,eax
	invoke FindFirstFile,offset Fbuff2,ADDR wfd2
	invoke FindClose,eax

	cmp D[edi+LVSORT.type],2
	ja >>D1
	mov eax,[wfd2.nFileSizeLow]
	cmp eax,[wfd1.nFileSizeLow]
	jmp >>.done

	; File date sort (3)
	D1:
	cmp D[edi+LVSORT.type],3
	ja >>U1
	mov eax,[wfd2.ftLastWriteTime+4]
	cmp eax,[wfd1.ftLastWriteTime+4]
	je >
	jmp >>.done
	:
	mov eax,[wfd2.ftLastWriteTime]
	cmp eax,[wfd1.ftLastWriteTime]
	jmp >>.done

	V1:
	xor eax,eax
	ret

	.done
	jae >
		mov eax,-1
		jmp >Z2
	:
	jne >
		mov eax,0
		jmp >Z2
	:
		mov eax,1
	Z2:

	or esi,esi
	jz >
		neg eax
	:
	ret

	U1:
	xor eax,eax
	ret
ENDF

TreeView_GetItemRoot FRAME htvitem
	uses esi
	mov esi,[htvitem]

	:
	invoke SendMessage,[hTreeView],TVM_GETNEXTITEM,TVGN_PARENT,esi
	or eax,eax
	jz >
	mov esi,eax
	jmp <
	:
	mov eax,esi
	RET
ENDF

BuildPathFromTreeview FRAME htvitem,FullPathBuffer
	LOCAL buffer0[MAX_PATH]		:B
	LOCAL buffer1[MAX_PATH]		:B
	LOCAL tvi					:TVITEM
	LOCAL tvitem				:D
	LOCAL hroot					:D

	mov eax,[FullPathBuffer]
	mov B[eax],0
	mov eax,offset buffer0
	mov D[eax],0

	invoke TreeView_GetItemRoot,[htvitem]
	mov [hroot],eax

	mov D[tvi.hItem],eax
	mov D[tvi.imask],TVIF_IMAGE + TVIF_TEXT
	mov eax,[FullPathBuffer]
	mov [tvi.pszText],eax
	mov D[tvi.cchTextMax],MAX_PATH


	invoke SendMessage,[hTreeView],TVM_GETITEM,0,ADDR tvi

	mov eax,[htvitem]
	cmp eax,[hroot]
	jne >
		; Special case for the root node
		ret
	:

	mov eax,[htvitem]
	mov [tvitem],eax


	mov [tvi.hItem],eax
	mov D[tvi.imask],TVIF_IMAGE + TVIF_TEXT
	lea eax,buffer1
	add eax,1
	mov B[eax],0
	mov [tvi.pszText],eax
	mov D[tvi.cchTextMax],MAX_PATH
	invoke SendMessage,[hTreeView],TVM_GETITEM,0,ADDR tvi

;	invoke szCopy,[NameBuffer],OFFSET buffer1+1
	mov B[buffer1],"\"

	; Is this a first level child ?
	invoke SendMessage,[hTreeView],TVM_GETNEXTITEM,TVGN_PARENT,[tvitem]
	or eax,eax
	jz >>.FIRSTLEVEL

	mov eax,[FullPathBuffer]
	mov D[eax],0

	; The path must be built backward to the root item
	:
	invoke SendMessage,[hTreeView],TVM_GETNEXTITEM,TVGN_PARENT,[tvitem]
	or eax,eax
	jz >>
	mov [tvitem],eax
	mov [tvi.hItem],eax
	mov D[tvi.imask],TVIF_TEXT
	lea eax,buffer0
	add eax,1
	mov B[buffer0],"\"
	mov [tvi.pszText],eax
	mov D[tvi.cchTextMax],MAX_PATH
	invoke SendMessage,[hTreeView],TVM_GETITEM,0,ADDR tvi
	invoke szCat,ADDR buffer0,ADDR buffer1
	invoke szCopy,ADDR buffer1,ADDR buffer0
	jmp <<
	:
	lea eax,buffer0
	add eax,1
	invoke szCat,[FullPathBuffer],eax

	ret
	.FIRSTLEVEL
	invoke szCat,[FullPathBuffer],ADDR buffer1
	ret
ENDF

WorkerThread FRAME lParam
	uses ebx,edi
	LOCAL tvi				:TVITEM
	LOCAL hdi				:HDITEM
	LOCAL szcount[MAX_PATH]	:B

	; Turn off header sort indicators 
	invoke SendMessage,[hHeader],HDM_GETITEMCOUNT,0,0
	mov ebx,eax
	xor edi,edi
	or eax,eax
	jz >L2
	L1:
		mov D[hdi._mask],HDI_IMAGE + HDI_FORMAT
		invoke SendMessage,[hHeader],HDM_GETITEM,edi,ADDR hdi
		test D[hdi.fmt],HDF_IMAGE
		jz >
			mov D[hdi.iImage],0
			invoke SendMessage,[hHeader],HDM_SETITEM,edi,ADDR hdi
		:
		inc edi
		cmp edi,ebx
		jle <L1
	L2:

	; Set the flags to no current item
	mov D[hdimage.dwItem],-1
	mov D[hdimage.dwDir],0

	mov ebx,[lParam]
	invoke TreeView_GetItemRoot,[ebx+4]

	mov [tvi.hItem],eax
	mov D[tvi.imask],TVIF_TEXT
	lea eax,szcount
	mov [tvi.pszText],eax
	mov D[tvi.cchTextMax],MAX_PATH
	invoke SendMessage,[hTreeView],TVM_GETITEM,0,offset tvi
	invoke szCat,offset szcount,"\*"
	invoke FindFirstFile,offset szcount,offset dcwfd
	or eax,eax
	js >

	invoke FindClose,eax
	xor eax,eax
	jmp >.OK

	:
	invoke GetLastError
	cmp eax,21 ;The device is not ready.
	jne >.OK
		invoke MessageBox,NULL,"The device is not ready.",NULL,MB_OK
		ret

	.OK
	mov ebx,[lParam]
	invoke ReadDir,[ebx],[ebx+4],[ebx+8]

	mov ebx,[ebx+4]

	;Expand the tree if necessary
	mov D[tvi.imask],TVIF_STATE
	mov [tvi.hItem],ebx
	invoke SendMessage,[hTreeView],TVM_GETITEM,0,offset tvi
	mov eax,[tvi.state]
	test eax,TVIS_EXPANDEDONCE
	jnz >
		;Sort the children

		invoke SendMessage,[hTreeView],TVM_SORTCHILDREN,0,ebx
		invoke SendMessage,[hTreeView],TVM_EXPAND,TVE_EXPAND,ebx
	:

	invoke SendMessage,[hListView],LVM_GETITEMCOUNT,0,0
	invoke dw2asc,eax,offset szcount
	invoke szCat,offset szcount," items"
	invoke SendMessage,[hStatusBar],SB_SETTEXT,NULL,offset szcount
	xor eax,eax
	invoke ExitThread,eax
	RET
ENDF

ListviewSelectView FRAME hWin
	uses esi,ebx
	LOCAL hPopMenu  :D
	LOCAL hMenu		:D
	LOCAL pt		:POINT
	LOCAL lvi		:LV_ITEM
	LOCAL lvhi		:LVHITTESTINFO

	invoke GetCursorPos, ADDR pt
	invoke ScreenToClient,[hWin],ADDR pt
	invoke ChildWindowFromPoint, [hWin], [pt.x], [pt.y]
	cmp eax,[hListView]
	jnz >>.DONE
		invoke GetCursorPos, ADDR pt
		invoke LoadMenu,[hInstance],10000
		mov [hMenu],eax
		invoke GetSubMenu,[hMenu],0
		mov [hPopMenu], eax
		invoke GetWindowLong,[hListView],GWL_STYLE
		mov esi,eax
		test eax,LVS_REPORT
		jnz >
			invoke EnableMenuItem,[hPopMenu],500,MF_ENABLED + MF_BYCOMMAND
			jmp >M1
		:
			invoke EnableMenuItem,[hPopMenu],500,MF_DISABLED + MF_GRAYED + MF_BYCOMMAND
		M1:

		invoke GetCursorPos, ADDR lvhi.pt
		invoke ScreenToClient,[hListView],ADDR lvhi.pt
		invoke SendMessage,[hListView],LVM_HITTEST,0,ADDR lvhi
		mov eax,[lvhi.iflags]
		test eax,LVHT_ONITEMICON+LVHT_ONITEMLABEL
		jz >
			invoke EnableMenuItem,[hPopMenu],501,MF_ENABLED + MF_BYCOMMAND
			jmp >M2
		:
			invoke EnableMenuItem,[hPopMenu],501,MF_DISABLED + MF_GRAYED + MF_BYCOMMAND
		M2:

		invoke TrackPopupMenu, [hPopMenu], TPM_LEFTALIGN + TPM_RETURNCMD,\
				[pt.x], [pt.y], NULL, [hListView], NULL
		or eax,eax
		jz >>.DONE
			cmp eax,500
			je >>.arrange
			cmp eax,501
			je >.open

			.view
				; Set view
				mov ebx,eax
				sub ebx,100
				and esi,0FFFFFFFCh
				or esi,ebx
				invoke SetWindowLong,[hListView],GWL_STYLE,esi
				jmp >>.REDRAW

			.open
				; Open
				mov eax,[lvhi.iItem]
				mov [lvi.iItem],eax
				mov D[lvi.iSubItem],0
				mov D[lvi.imask],LVIF_PARAM+LVIF_TEXT
				mov [lvi.pszText],offset pszSelName
				mov D[lvi.cchTextMax],MAX_PATH
				invoke SendMessage,[hListView],LVM_GETITEM,0,offset lvi
				invoke BuildPathFromTreeview,[lvi.lParam],offset pszSelPath
				invoke szCat,offset pszSelPath,"\"
				invoke szCat,offset pszSelPath,offset pszSelName
				invoke ShellExecute,NULL,"Open",offset pszSelPath,NULL,NULL,SW_SHOW
				jmp >>.DONE

			.arrange
				invoke SendMessage,[hListView],LVM_ARRANGE,LVA_DEFAULT,0
				jmp >>.REDRAW

		.REDRAW
		invoke InvalidateRect,[hListView],NULL,NULL
		invoke UpdateWindow,[hListView]
		invoke DestroyMenu,[hMenu]
	.DONE
	RET
ENDF

Is9x FRAME
	LOCAL osvi	:OSVERSIONINFO
	
	mov D[osvi.dwOSVersionInfoSize],SIZEOF OSVERSIONINFO
	invoke GetVersionEx,offset osvi
	
	mov eax,0
	cmp D[osvi.dwPlatformId],VER_PLATFORM_WIN32_WINDOWS
	jne >
		mov eax,1
		cmp D[osvi.dwMinorVersion],0
		jne >
		mov eax,2
	:
	RET
ENDF

PathTohItem FRAME pszSearchPath
	uses edi,esi,ebx
	LOCAL PathPart[MAX_PATH]	:B
	LOCAL FilePath[MAX_PATH]	:B

	; First make sure the file exists, this gets rid of bad paths quickly
	invoke GetFileAttributes,[pszSearchPath]
	or eax,eax
	jns >
		xor eax,eax
		ret
	:

	; Going to have to scan forward through the path
	; using szToken from the string library

	; szToken destroys the original string so copy it first
	invoke szCopy,offset PathPart,[pszSearchPath]

	; set the default return value to 0
	xor ebx,ebx

	; First find the correct drive
	invoke szToken,offset PathPart,"\"
	invoke TreeViewFindItem,0,eax
	or eax,eax
	jz >L2

	; Begin the scan, building the tree where necessary
	L1:
		mov ebx,eax
		invoke szToken,NULL,"\"
		mov esi,eax
		invoke szLen,esi
		or eax,eax
		jz >L2
		invoke TreeViewFindItem,ebx,esi
		or eax,eax
		jnz <L1

		; The subfolder was not found so build the path at ebx
		invoke BuildPathFromTreeview,ebx,offset FilePath
		invoke ReadDirFolders,offset FilePath,ebx,FALSE
		invoke TreeViewFindItem,ebx,esi
		or eax,eax
		jnz <L1
		xor ebx,ebx
	L2:
	mov eax,ebx

	RET
ENDF

TreeViewFindItem FRAME hParent,pszItem
	uses edi
	LOCAL tvi					:TVITEM
	LOCAL TextBuffer[MAX_PATH]	:B

	lea eax,TextBuffer
	mov [tvi.pszText],eax
	mov D[tvi.cchTextMax],MAX_PATH
	mov D[tvi.imask],TVIF_TEXT

	mov edi,[hParent]
	or edi,edi
	jnz >
		invoke SendMessage,[hTreeView],TVM_GETNEXTITEM,TVGN_ROOT,0
		mov edi,eax
		jmp >L1
	:
		invoke SendMessage,[hTreeView],TVM_GETNEXTITEM,TVGN_CHILD,edi
		mov edi,eax
		or edi,edi
		jnz >L1
		ret

	L1:
		mov [tvi.hItem],edi
		invoke SendMessage,[hTreeView],TVM_GETITEM,0,offset tvi
		invoke szCmpi,offset TextBuffer,[pszItem]
		or eax,eax
		jz >L2
		invoke SendMessage,[hTreeView],TVM_GETNEXTITEM,TVGN_NEXT,edi
		mov edi,eax
		or eax,eax
		jnz <L1
		ret
	L2:

	mov eax,edi
	
	RET
ENDF

ReadDirFolders FRAME pszFolder,hParent,lParam
	LOCAL folder[MAX_PATH]	:B
	LOCAL tvi				:TVITEM

	mov eax,[lParam]
	or eax,eax
	jnz >
		; If the thread was interupted then the folders must be redone
		invoke SendMessage,[hTreeView],TVM_EXPAND,TVE_COLLAPSE + TVE_COLLAPSERESET,[hParent]
	:

	invoke szCopy,offset folder,[pszFolder]
	invoke szCat,offset folder,"\*"
	invoke FindFirstFile,offset folder,OFFSET wfd
	mov [hFind],eax
	L1:
		mov eax,[wfd.dwFileAttributes]
		test eax,FILE_ATTRIBUTE_HIDDEN
		jnz >>.NEXTITEM
		test eax,FILE_ATTRIBUTE_DIRECTORY
		jz >.NEXTITEM
		mov eax,[lParam]
		or eax,eax
		jnz >.NEXTITEM
			mov eax,[wfd.cFileName]
			and eax,0FFFFFFh
			cmp eax,2E2Eh
			je >.NEXTITEM
			and eax,0FFFFh
			cmp eax,2Eh
			je >.NEXTITEM
			invoke DetectChildren,offset folder,offset wfd.cFileName
			invoke TrvAddItem,[hTreeView],[hParent],offset wfd.cFileName,I_IMAGECALLBACK,eax
	.NEXTITEM
	invoke FindNextFile,[hFind],offset wfd
	or eax,eax
	jne	<<L1

	;No more matches, close handle
	invoke FindClose,[hFind]
	mov D[hFind],0

	invoke SendMessage,[hTreeView],TVM_GETNEXTITEM,TVGN_CHILD,[hParent]
	or eax,eax
	jnz >
		mov D[tvi.imask],TVIF_CHILDREN +TVIF_PARAM
		mov eax,[hParent]
		mov [tvi.hItem],eax
		mov D[tvi.cChildren],0
		mov D[tvi.lParam],TRUE
		invoke SendMessage,[hTreeView],TVM_SETITEM,0,offset tvi
	:

	xor eax,eax
	RET
	
ENDF

DetectChildren FRAME szParent,szFolder
	uses ebx
	LOCAL szp[MAX_PATH]	:B
	
	invoke szCopy,offset szp,[szParent]
	invoke szLen,offset szp
	lea eax,[szp+eax-1]
	invoke szCopy,eax,[szFolder]
	invoke szCat,offset szp,"\*"

	invoke FindFirstFile,offset szp,offset dcwfd
	mov [hdcFind],eax
	or eax,eax
	js >.NOCHILDREN
	
	xor ebx,ebx
	; Must find 3 directories . .. and a real one
	L1:
	mov eax,[dcwfd.dwFileAttributes]
	test eax,FILE_ATTRIBUTE_DIRECTORY
	jz >
		inc ebx
		cmp ebx,3
		je >.CHILDREN
	:
	invoke FindNextFile,[hdcFind],offset dcwfd
	or eax,eax
	jne	<<L1

	.NOCHILD
	invoke FindClose,[hdcFind]
	xor eax,eax
	ret

	.CHILDREN
	invoke FindClose,[hdcFind]
	xor eax,eax
	inc eax
	ret

	.NOCHILDREN
	xor eax,eax
	ret
ENDF

FindDlgProc FRAME hwnd,uMsg,wParam,lParam
	LOCAL szFileSpec[64]			:B
	LOCAL szSearchPath[MAX_PATH]	:B
	LOCAL tvi						:TVITEM
	LOCAL DoEventsID				:D
	LOCAL dwECode					:D

	cmp D[uMsg],WM_INITDIALOG
	jne >.WM_COMMAND
		invoke SetDlgItemText,[hwnd],1001,[lParam]
		jmp >>.DEFPROC

	.WM_COMMAND
	cmp D[uMsg],WM_COMMAND
	jne >>.WM_CLOSE
		movzx eax,W[wParam]
		cmp eax,1008 ; Browse
		jne >
			invoke szCopy,offset BIInfo.szStatusTxt,"Find files"
			mov D[BIInfo.szInitPath],NULL
			invoke BrowseForFolder,[hwnd],OFFSET szSearchPath,OFFSET BIInfo,"Choose a folder to search"
			invoke SetDlgItemText,[hwnd],1001,OFFSET szSearchPath
			jmp >>.EXIT
		:
		cmp eax,1005 ;search
		jne >>
			; Have to run the find in a thread so that we can
			; stop it if necessary
			mov D[fContinue],TRUE
			invoke CreateThread,NULL,NULL,OFFSET FindFilesThread,[hwnd],NULL,ADDR DoEventsID
			mov [hThread],eax
			invoke SetThreadPriority,[hThread],THREAD_PRIORITY_ABOVE_NORMAL
			jmp >>.EXIT
		:
		cmp eax,1006
		jne >>.DEFPROC
			mov D[fContinue],FALSE
		jmp >.DEFPROC
		
		
	.WM_CLOSE
	cmp D[uMsg],WM_CLOSE
	jne >.DEFPROC
		; Force a normal exit from the thread
		mov D[fContinue],FALSE
		:
		invoke GetExitCodeThread,[hThread],offset dwECode
		mov eax,[dwECode]
		test eax,STILL_ACTIVE
		jnz <

		invoke CloseHandle,[hThread]
		mov D[hThread],NULL
		INVOKE EndDialog,[hwnd],0

	.DEFPROC
		xor eax,eax
		ret

	.EXIT

	xor eax,eax
	inc eax
	RET
ENDF

FindFilesThread FRAME lParam
	LOCAL hHeap			:D
	LOCAL pSearchFolder	:D
	LOCAL pSearchFile	:D

	invoke GetProcessHeap
	mov [hHeap],eax
	invoke HeapAlloc,[hHeap],HEAP_ZERO_MEMORY,1024
	mov [pSearchFolder],eax
	invoke HeapAlloc,[hHeap],HEAP_ZERO_MEMORY,1024
	mov [pSearchFile],eax
	
	mov D[SearchWindow],TRUE
	mov D[fContinue],TRUE
	mov eax,[pSearchFile]
	mov B[eax],"\"
	invoke GetDlgItemText,[lParam],1001,[pSearchFolder],MAX_PATH
	mov eax,[pSearchFile]
	inc eax
	invoke GetDlgItemText,[lParam],1002,eax,64
	invoke SendMessage,[hListView],LVM_DELETEALLITEMS,0,0
	
	invoke PathFindFiles,[pSearchFolder],[pSearchFile]
	invoke SendDlgItemMessage,[lParam],1004,BM_GETCHECK,0,0
	test eax,BST_CHECKED 
	jz >
	invoke RecurseFindFiles,[pSearchFolder],[pSearchFile],offset fContinue
	:
	invoke HeapFree,[hHeap],NULL,[pSearchFolder]
	invoke HeapFree,[hHeap],NULL,[pSearchFile]

	invoke PostMessage,[lParam],WM_CLOSE,0,0
	xor eax,eax
	invoke ExitThread,eax
	RET
ENDF

RecurseFindFiles FRAME lpPath,pFileSpec,pfContinue
	uses edi
	LOCAL hrffFind			:D

	mov eax,[pfContinue]
	mov eax,[eax]
	or eax,eax
	jz >>E1

	invoke szCopy,offset rfffolder,[lpPath]
	invoke szCat,offset rfffolder,"\*"
	invoke FindFirstFile,offset rfffolder,OFFSET wfd
	mov [hrffFind],eax
	or eax,eax
	js >>E1
	L1:
		mov eax,[pfContinue]
		mov eax,[eax]
		or eax,eax
		jz >>L2
		mov eax,[wfd.dwFileAttributes]
		test eax,FILE_ATTRIBUTE_DIRECTORY
		jz >.NEXTITEM
		mov eax,[wfd.dwFileAttributes]
		test eax,FILE_ATTRIBUTE_HIDDEN
		jnz >>.NEXTITEM
			mov eax,[wfd.cFileName]
			and eax,0FFFFFFh
			cmp eax,2E2Eh
			je >.NEXTITEM
			and eax,0FFFFh
			cmp eax,2Eh
			je >.NEXTITEM
				invoke szLen,addr rfffolder
				mov ecx,eax
				lea edi,[rfffolder+eax]
				std
				mov al,"\"
				repne scasb
				cld
				add edi,2
				push edi
				invoke szCopy,edi,offset wfd.cFileName
				invoke PathFindFiles,addr rfffolder,[pFileSpec]
				invoke RecurseFindFiles,addr rfffolder,[pFileSpec],[pfContinue]
				pop edi
				mov W[edi],"*"
	.NEXTITEM
	invoke FindNextFile,[hrffFind],offset wfd
	or eax,eax
	jne	<<L1
	L2:
	invoke FindClose,[hrffFind]
	E1:

	RET
ENDF

PathFindFiles FRAME lpPth,pFileSpec
	uses edi
	LOCAL szBuffer[MAX_PATH]	:B
	LOCAL hThisParent			:D
	LOCAL tvi					:TVITEM

	invoke PathTohItem,[lpPth]
	mov [hThisParent],eax
	or eax,eax
	jnz >
		; could not resolve hItem
		ret
	:

	invoke szCopy,addr szBuffer,[lpPth]
	invoke szCat,addr szBuffer,[pFileSpec]
	invoke FindFirstFile,addr szBuffer,addr ffwfd
	cmp eax,INVALID_HANDLE_VALUE
	je >E2
		;Save returned handle
		mov [hffFind],eax
	  N1:
	  	mov eax,[ffwfd.dwFileAttributes]
	  	test eax,FILE_ATTRIBUTE_DIRECTORY
	  	jnz >N2
		invoke szLen,addr szBuffer
		mov ecx,eax
		lea edi,[szBuffer+eax]
		std
		mov al,"\"
		repne scasb
		cld
		mov B[edi+3],0
		;invoke szCopy,edi,addr ffwfd.cFileName
		/*
		A fully qualified path and filename is in szBuffer
		*/
		invoke FileToListview,offset szBuffer,addr ffwfd.cFileName,[hThisParent],offset ffwfd
		N2:
		invoke FindNextFile,[hffFind],addr ffwfd
		or eax,eax
	jne	<N1
	E1:
	invoke FindClose,[hffFind]
	E2:
	ret
ENDF

BrowseForFolder FRAME hParent,lpBuffer,lpTitle,lpString
	LOCAL lpIDList	:D
	LOCAL bi  		:BROWSEINFO

	mov eax,[hParent]
	mov D[bi.hwndOwner],eax
	mov D[bi.pidlRoot],0
	mov D[bi.pszDisplayName],0
	mov eax,[lpString]
	mov D[bi.lpszTitle],eax
	mov D[bi.ulFlags],BIF_RETURNONLYFSDIRS + BIF_DONTGOBELOWDOMAIN
	mov D[bi.lpfn],offset cbBrowse
	mov eax,[lpTitle]
	mov D[bi.lParam],eax
	mov D[bi.iImage],0

	invoke SHBrowseForFolderA,offset bi
	mov [lpIDList], eax

	cmp D[lpIDList],0
	jne >
		xor eax,eax
		push eax
		jmp >.EXIT
	:
		invoke SHGetPathFromIDListA,[lpIDList],[lpBuffer]
		xor eax,eax
		inc eax
		push eax
	.EXIT

	invoke CoTaskMemFree,[lpIDList]

	pop eax
	ret

ENDF

cbBrowse FRAME hwnd,uMsg,lParam,lpData

	cmp D[uMsg],BFFM_INITIALIZED
	jne >>
		invoke SetWindowText,[hwnd],[lpData]
		mov eax,[lpData]
		mov eax,[eax+BFFINFO.szInitPath]
		or eax,eax
		jz >
			mov eax,[lpData]
			add eax,BFFINFO.szInitPath
			invoke SendMessage,[hwnd],BFFM_SETSELECTIONA,TRUE,eax
		:
	:

    ret
ENDF
